VERSION 5.00
Object = "{ECEDB943-AC41-11D2-AB20-000000000000}#2.0#0"; "CMAX20.OCX"
Begin VB.Form frmDoc 
   ClientHeight    =   2940
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4275
   Icon            =   "frmDoc.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   2940
   ScaleWidth      =   4275
   WindowState     =   2  'Maximized
   Begin CodeMaxCtl.CodeMax rt 
      Height          =   2325
      Left            =   75
      OleObjectBlob   =   "frmDoc.frx":1042
      TabIndex        =   0
      Top             =   105
      Width           =   3600
   End
End
Attribute VB_Name = "frmDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public TabNum As Long
Public Changed As Boolean
Public filename As String
Public r As CodeMaxCtl.Range
Public FTP As Boolean
Public IsFile As Boolean
Public FTPAccount As String
Public ftpDir As String
Private LastLine As New Collection
Private LineIndex As Long

Private Sub Form_Activate()
  dnum = Me.Tag
  frmMain.TB.Tabs("key" & Me.Tag).Caption = StripPath(Me.Caption)
  frmMain.TB.Tabs("key" & Me.Tag).Selected = True
  frmMain.TB.Tabs("key" & Me.Tag).ToolTipText = Me.Caption
  If Changed = False Then
    frmMain.TB.Tabs("key" & Me.Tag).Image = 1
  Else
    frmMain.TB.Tabs("key" & Me.Tag).Image = 2
  End If
  EnableMac
  EnableMenu
  OpenAble
  ShouldEnable
  If rt.language = "" Then
    frmMain.stBar.Panels(3).Text = "Text"
  Else
    frmMain.stBar.Panels(3).Text = rt.language
  End If
End Sub

Private Sub Form_Load()
  On Error Resume Next
  frmMain.TB.Tabs.Add fIndex, ("key" & Format(fIndex)), "me.tag: " & Me.Tag    'Me.Caption  AddLang
  ReadOptions rt
  ReadInput
  Clear
  LastLine.Add 0
  LineIndex = 1
  If WhiteSpaced = True Then
    rt.DisplayWhitespace = True
  Else
    rt.DisplayWhitespace = False
  End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Dim msgRes As VbMsgBoxResult
  If Changed = True Then
    msgRes = MsgBox("Document: " & Me.Caption & Chr(10) & "Do you wish to save?", vbYesNoCancel + vbQuestion, "Save")
    If msgRes = vbYes Then
      doSave
    ElseIf msgRes = vbNo Then
      'do nothing
    ElseIf msgRes = vbCancel Then
      'Cancel
      Cancel = 1
      StopClose = True
      rt.SetFocus
    End If
  End If
End Sub

Private Sub Form_Resize()
  On Error Resume Next
  
  rt.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error Resume Next
  
  DisableMac
  DisableMenu
  CloseAble
  FState(Me.Tag).Deleted = True
  frmMain.TB.Tabs.Remove ("key" & Format(Me.Tag))
  dnum = 0
End Sub

Private Sub rt_Change(ByVal Control As CodeMaxCtl.ICodeMax)
  If Changed = False Then
    Changed = True
    frmMain.TB.Tabs("key" & Me.Tag).Image = 2
  End If
End Sub


Private Sub rt_GotFocus()
  Dim X As Integer
  SetLang
  For X = 1 To frmMain.TB.Tabs.Count
    If frmMain.TB.Tabs(X).Tag = Me.TabNum Then
      frmMain.TB.Tabs(X).Selected = True
      Exit For
    End If
  Next
End Sub

Private Function rt_MouseDown(ByVal Control As CodeMaxCtl.ICodeMax, ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long) As Boolean
  If Button = 2 Then PopupMenu frmMain.edit
End Function


Private Sub rt_SelChange(ByVal Control As CodeMaxCtl.ICodeMax)
  On Error Resume Next
  Set r = rt.GetSel(True)
  frmMain.stBar.Panels(2).Text = "Ln " & r.EndLineNo + 1 & ", Col. " & r.EndColNo & ", Lines " & rt.LineCount
  If HighLight = True Then
    rt.HighlightedLine = r.EndLineNo
  Else
    rt.HighlightedLine = -1
  End If
  If LastLine.Count <> 0 Then
    If LastLine(LineIndex) <> r.EndLineNo Then
      LastLine.Add r.EndLineNo
      LineIndex = LastLine.Count
    End If
  Else
    LastLine.Add r.EndLineNo
    LineIndex = LastLine.Count
  End If
  If LineIndex < LastLine.Count Then
    frmMain.tBar.Buttons(39).Enabled = True
  Else
    frmMain.tBar.Buttons(39).Enabled = False
  End If
  
  If LineIndex > 1 Then
    frmMain.tBar.Buttons(38).Enabled = True
  Else
    frmMain.tBar.Buttons(38).Enabled = False
  End If
  ShouldEnable
End Sub

Private Sub SetLang()
  setChk
End Sub

Private Sub setChk()
  Dim X As Integer
  For X = 0 To frmMain.lang.Count - 1
    If LCase(rt.language) = LCase(frmMain.lang(X).Caption) Or (X = 0 And rt.language = "") Then
      frmMain.lang(X).Checked = True
    Else
      frmMain.lang(X).Checked = False
    End If
  Next
End Sub

Public Sub NextLine()
  If LineIndex + 1 > LastLine.Count Then Exit Sub 'this won't work we are at the end of lines
  LineIndex = LineIndex + 1
  'rt.ExecuteCmd cmCmdGotoLine, LastLine(LineIndex)
  rt.SetCaretPos LastLine(LineIndex), 1
  If LineIndex < LastLine.Count Then
    frmMain.tBar.Buttons(39).Enabled = True
  Else
    frmMain.tBar.Buttons(39).Enabled = False
  End If
  
  If LineIndex > 1 Then
    frmMain.tBar.Buttons(38).Enabled = True
  Else
    frmMain.tBar.Buttons(38).Enabled = False
  End If
End Sub

Public Sub PrevLine()
  If LineIndex - 1 < 1 Then Exit Sub 'this won't work we are at the end of lines
  LineIndex = LineIndex - 1
  rt.SetCaretPos LastLine(LineIndex), 1
  If LineIndex < LastLine.Count Then
    frmMain.tBar.Buttons(39).Enabled = True
  Else
    frmMain.tBar.Buttons(39).Enabled = False
  End If
  
  If LineIndex > 1 Then
    frmMain.tBar.Buttons(38).Enabled = True
  Else
    frmMain.tBar.Buttons(38).Enabled = False
  End If
End Sub

Public Sub CommentBlock()
  If rt.language = "" Then Exit Sub
  Dim I As Integer
  Dim p As CodeMaxCtl.language
  Dim s As CodeMaxCtl.globals
  Set s = New CodeMaxCtl.globals
  Dim UA() As String
  Dim cmstring As String
  Dim NewStr As String
  Set p = s.GetLanguageDef(rt.language)
  cmstring = p.SingleLineComments
  Set p = Nothing
  Set s = Nothing
  NewStr = ""
  UA = Split(rt.SelText, Chr$(10))
  For I = 0 To UBound(UA)
    NewStr = NewStr & cmstring & UA(I)
  Next
  Erase UA
  InsertString rt, NewStr
  NewStr = ""
  cmstring = ""
End Sub

Public Sub UncommentBlock()
  If rt.language = "" Then Exit Sub
  Dim p As CodeMaxCtl.language
  Dim s As CodeMaxCtl.globals, cmstring As String
  Set s = New CodeMaxCtl.globals
  Set p = s.GetLanguageDef(rt.language)
  cmstring = p.SingleLineComments
  Set p = Nothing
  Set s = Nothing
  InsertString rt, Replace(rt.SelText, cmstring, "")
End Sub

Private Sub Clear()
  Dim X As Integer
  For X = LastLine.Count To 1 Step -1
    LastLine.Remove (X)
  Next
End Sub

Public Sub DoAct()
  frmMain.TB.Tabs("key" & Me.Tag).Caption = StripPath(Me.Caption)
  frmMain.TB.Tabs("key" & Me.Tag).Selected = True
  frmMain.TB.Tabs("key" & Me.Tag).ToolTipText = Me.Caption
  If Changed = False Then
    frmMain.TB.Tabs("key" & Me.Tag).Image = 1
  Else
    frmMain.TB.Tabs("key" & Me.Tag).Image = 2
  End If
End Sub

Private Sub EnableMac()
  Dim X As Integer
  If (frmMain.tbMacro.Buttons("mac1").Enabled) = True Then Exit Sub 'They are already enabled
  For X = 1 To 10
    frmMain.tbMacro.Buttons("mac" & X).Enabled = True
  Next
  frmMain.tbMacro.Buttons("cmac").Enabled = True
End Sub

Private Sub DisableMac()
  Dim X As Integer
  If frmMain.tbMacro.Buttons("mac1").Enabled = False Then Exit Sub
  If closeall = True Then Exit Sub
  For X = 1 To 10
    frmMain.tbMacro.Buttons("mac" & X).Enabled = False
  Next
  frmMain.tbMacro.Buttons("cmac").Enabled = False
End Sub

Private Sub DisableMenu()
  Dim X As Integer
  If frmMain.close.Enabled = False Then Exit Sub  'Just make sure it's not already done to save the effort
  frmMain.close.Enabled = False
  frmMain.save.Enabled = False
  frmMain.saveas.Enabled = False
  frmMain.saveall.Enabled = False
  frmMain.saveto.Enabled = False
  frmMain.prints.Enabled = False
  frmMain.printsetup.Enabled = False
  frmMain.properties.Enabled = False
  frmMain.undo.Enabled = False
  frmMain.redo.Enabled = False
  frmMain.cut.Enabled = False
  frmMain.copy.Enabled = False
  frmMain.paste.Enabled = False
  frmMain.delete.Enabled = False
  frmMain.mnuComment.Enabled = False
  frmMain.mnuUncomment.Enabled = False
  frmMain.selectall.Enabled = False
  frmMain.selectline.Enabled = False
  frmMain.datetime.Enabled = False
  frmMain.find.Enabled = False
  frmMain.findnext.Enabled = False
  frmMain.findprev.Enabled = False
  frmMain.mnuReplace.Enabled = False
  frmMain.goto.Enabled = False
  frmMain.mnuToggle.Enabled = False
  frmMain.mnuNext.Enabled = False
  frmMain.mnuPrev.Enabled = False
  frmMain.mnuClear.Enabled = False
  frmMain.mnuNLine.Enabled = False
  frmMain.mnuLPrev.Enabled = False
  frmMain.countall.Enabled = False
  For X = 0 To frmMain.lang.Count - 1
    If X <> 8 Then frmMain.lang(X).Enabled = False
  Next
  frmMain.mnuCompile.Enabled = False
  frmMain.mnuBuildConfig.Enabled = False
  For X = 1 To 10
    frmMain.mac(X).Enabled = False
  Next
  frmMain.mnuSave.Enabled = False
  frmMain.mnuCreate.Enabled = False
  frmMain.tilehor.Enabled = False
  frmMain.tilever.Enabled = False
  frmMain.arrangeicons.Enabled = False
  frmMain.cascade.Enabled = False
  frmMain.closeall.Enabled = False
  frmMain.inbrowser.Enabled = False
  frmMain.wnlist.Enabled = False
End Sub

Private Sub EnableMenu()
  Dim X As Integer
  If frmMain.close.Enabled = True Then Exit Sub
  If closeall = True Then Exit Sub
  frmMain.close.Enabled = True
  frmMain.save.Enabled = True
  frmMain.saveas.Enabled = True
  frmMain.saveall.Enabled = True
  frmMain.saveto.Enabled = True
  frmMain.prints.Enabled = True
  frmMain.printsetup.Enabled = True
  frmMain.properties.Enabled = True
  frmMain.undo.Enabled = True
  frmMain.redo.Enabled = True
  frmMain.cut.Enabled = True
  frmMain.copy.Enabled = True
  frmMain.paste.Enabled = True
  frmMain.delete.Enabled = True
  frmMain.mnuComment.Enabled = True
  frmMain.mnuUncomment.Enabled = True
  frmMain.selectall.Enabled = True
  frmMain.selectline.Enabled = True
  frmMain.datetime.Enabled = True
  frmMain.find.Enabled = True
  frmMain.findnext.Enabled = True
  frmMain.findprev.Enabled = True
  frmMain.mnuReplace.Enabled = True
  frmMain.goto.Enabled = True
  frmMain.mnuToggle.Enabled = True
  frmMain.mnuNext.Enabled = True
  frmMain.mnuPrev.Enabled = True
  frmMain.mnuClear.Enabled = True
  frmMain.mnuNLine.Enabled = True
  frmMain.mnuLPrev.Enabled = True
  frmMain.countall.Enabled = True
  For X = 0 To frmMain.lang.Count - 1
    If X <> 8 Then frmMain.lang(X).Enabled = True
  Next
  frmMain.mnuCompile.Enabled = True
  frmMain.mnuBuildConfig.Enabled = True
  For X = 1 To 10
    frmMain.mac(X).Enabled = True
  Next
  frmMain.mnuSave.Enabled = True
  frmMain.mnuCreate.Enabled = True
  frmMain.tilehor.Enabled = True
  frmMain.tilever.Enabled = True
  frmMain.arrangeicons.Enabled = True
  frmMain.cascade.Enabled = True
  frmMain.closeall.Enabled = True
  frmMain.inbrowser.Enabled = True
  frmMain.wnlist.Enabled = True
End Sub

Private Sub CloseAble()
  ' This is a simple function which will
  ' disable all the unnecisary toolbar buttons
  ' on the main toolbar when the form unloads.
  
  ' First off lets check a button which is always
  ' enabled if a doc is open but never enabled if
  ' it's not and check (just to avoid doing this if
  ' their already disabled
  If (frmMain.tBar.Buttons("close").Enabled = False) Then Exit Sub 'Exit sub if it's already disabled
  
  With frmMain.tBar
    .Buttons("close").Enabled = False
    .Buttons("save").Enabled = False
    .Buttons("saveas").Enabled = False
    .Buttons("saveall").Enabled = False
    .Buttons("reload").Enabled = False
    .Buttons("print").Enabled = False
    .Buttons("undo").Enabled = False
    .Buttons("redo").Enabled = False
    .Buttons("cut").Enabled = False
    .Buttons("copy").Enabled = False
    .Buttons("paste").Enabled = False
    .Buttons("delete").Enabled = False
    .Buttons("find").Enabled = False
    .Buttons("findnext").Enabled = False
    .Buttons("findprev").Enabled = False
    .Buttons("tabl").Enabled = False
    .Buttons("tabr").Enabled = False
    .Buttons("cblock").Enabled = False
    .Buttons("ublock").Enabled = False
    .Buttons("tbmark").Enabled = False
    .Buttons("nbmark").Enabled = False
    .Buttons("pbmark").Enabled = False
    .Buttons("cbmark").Enabled = False
    .Buttons("nline").Enabled = False
    .Buttons("pline").Enabled = False
    .Buttons("nline").Enabled = False
    .Buttons("ctag").Enabled = False
    .Buttons("tilehor").Enabled = False
    .Buttons("tilever").Enabled = False
    .Buttons("cascade").Enabled = False
  End With
End Sub

Private Sub OpenAble()
  ' This function will enabled all the neccisary buttons on the primary toolbar
  ' Please note not all the toolbar buttons will automaticly be enabled
  ' as some are dependant on certain factors.
  
  ' Check to verify their not already enabled cause if they are
  ' we don't need to waste the processor time on this
  If (frmMain.tBar.Buttons("close").Enabled = True) Then Exit Sub ' If it's enabled already just exit this sub
  
  With frmMain.tBar
    .Buttons("close").Enabled = True
    .Buttons("save").Enabled = True
    .Buttons("saveas").Enabled = True
    .Buttons("saveall").Enabled = True
    .Buttons("reload").Enabled = True
    .Buttons("delete").Enabled = True
    .Buttons("print").Enabled = True
    .Buttons("find").Enabled = True
    .Buttons("findnext").Enabled = True
    .Buttons("findprev").Enabled = True
    .Buttons("tabl").Enabled = True
    .Buttons("tabr").Enabled = True
    .Buttons("cblock").Enabled = True
    .Buttons("ublock").Enabled = True
    .Buttons("tbmark").Enabled = True
    .Buttons("nbmark").Enabled = True
    .Buttons("pbmark").Enabled = True
    .Buttons("cbmark").Enabled = True
    .Buttons("nline").Enabled = True
    .Buttons("pline").Enabled = True
    .Buttons("ctag").Enabled = True
    .Buttons("tilehor").Enabled = True
    .Buttons("tilever").Enabled = True
    .Buttons("cascade").Enabled = True
  End With
End Sub

Private Sub ShouldEnable()
  ' This simple function will simply check if the
  ' several different things can take place and then
  ' depending on that enable or disable certain buttons
  ' on the toolbar.
  
  With frmMain.tBar
    If rt.CanUndo Then
      .Buttons("undo").Enabled = True
    Else
      .Buttons("undo").Enabled = False
    End If
    If rt.CanRedo Then
      .Buttons("redo").Enabled = True
    Else
      .Buttons("redo").Enabled = False
    End If
    If rt.CanCut Then
      .Buttons("cut").Enabled = True
    Else
      .Buttons("cut").Enabled = False
    End If
    If rt.CanCopy Then
      .Buttons("copy").Enabled = True
    Else
      .Buttons("copy").Enabled = False
    End If
    If rt.CanPaste Then
      .Buttons("paste").Enabled = True
    Else
      .Buttons("paste").Enabled = False
    End If
  End With
End Sub

